﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using S7Explorer.ViewModels;

namespace S7Explorer.Views
{
    public partial class MainWindow : Window
    {
        private MainViewModel ViewModel => (MainViewModel)DataContext;

        public MainWindow()
        {
            InitializeComponent();
            DataContext = new MainViewModel();

            // Configurar TextBox de log para Auto-scroll
            SetupLogTextBox();
        }

        private void SetupLogTextBox()
        {
            // Auto-scroll al final del texto cuando se actualiza
            if (LogTextBox != null)
            {
                DependencyPropertyDescriptor.FromProperty(TextBox.TextProperty, typeof(TextBox))
                    .AddValueChanged(LogTextBox, (s, e) =>
                    {
                        LogTextBox.ScrollToEnd();
                    });
            }
        }

        private void TreeView_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (ViewModel != null)
            {
                ViewModel.SelectedTreeItem = e.NewValue;
            }
        }

        private void SearchBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter && ViewModel != null)
            {
                ViewModel.SearchCommand.Execute(null);
                e.Handled = true;
            }
        }
    }
}